-- Filename:     prior.vhd
-- Filetype:     VHDL code (dataflow)
-- Date:         9 feb 2014
-- Update:       -
-- Description:  An example of a CSA
-- Author:       J. op den Brouw
-- State:        demo
-- Error:        -
-- Version:      1.0
-- Copyright:    (c)2014, De Haagse Hogeschool
--
-- This is an example of a Concurrent Signal Assignment
-- which implements a priority on the sampled inputs.
--
-- We need std_logic et al.

library ieee;
use ieee.std_logic_1164.all;

entity prior is
    port (a,b,c,d,en,data,reset: in std_logic;
          s : out std_logic);
end entity prior;

architecture behav of prior is
begin
    s <= a  when en = '1' else
         b  when data = '0' else
         c  when reset = '1' else
         d;
end architecture behav;